# Basic utilities set include for many Perl programs.
# Andrew Bedno - 2006.01.12 - http://bedno.com/andrew.

# Time setup.
# Accurate method, doesn't work under Win/DOS.
# $TZ = $ENV{'TZ'};
# if ( ($TZ ne '') and ($TZ =~ /([\-0-9]+)/) ) {
#   $TZ_adjust = $1;  # Negative hours between GMT and local.
# }
# $local_time = time - ($TZ_adjust * 60 * 60);
# $TZ_adjust = 1;
$TZ_adjust = 0;
if ($local_mode) { $TZ_adjust = -1; }
($junk,$junk,$junk,$junk,$junk,$junk,$junk,$junk,$DST) = localtime();
if ($DST) { $TZ_adjust++ }
$local_time = time - ($TZ_adjust * 60 * 60);
($Sec, $Min, $Hr, $Da, $Mo, $Yr, $DOW) = localtime($local_time);
$Mo++;  $Yr += 1900;
$YYYYMMDD = sprintf("%04d%02d%02d", $Yr, $Mo, $Da);
$HHMMSS = sprintf("%02d%02d%02d", $Hr, $Min, $Sec);
$YYYYMMDDHHMMSS = $YYYYMMDD.$HHMMSS;
$Today_show = sprintf("%04d.%02d.%02d %02d:%02d:%02d", $Yr, $Mo, $Da, $Hr, $Min, $Sec);

@DayNames = ('Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday');
@day_code = ('su', 'mo', 'tu', 'we', 'th', 'fr', 'sa');
@MonthNames = ('January', 'February', 'March', 'April', 'May', 'June',
        'July', 'August', 'September', 'October', 'November', 'December');
@DaysPerMonth = ( 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 );
@media_ext = ('avi', 'mpg', 'mp2', 'rm', 'ram');

@cookies = split(/;/, $ENV{'HTTP_COOKIE'});
foreach $cookie_pair (@cookies) {
  ($cookie_name, $cookie_value) = split(/=/, $cookie_pair);
  $cookie_name =~ s/[^a-zA-Z0-9]//g;
  $cookie_name = lc($cookie_name);
  $cookie{$cookie_name} = $cookie_value;
}

$PAGE_TITLE = '';

# Remove lead/trail space/tab/lf/cr
sub cleanse {
  $cleanse_tmp = $_[0];
  $cleanse_tmp =~ s/\|//gm;
  $cleanse_tmp =~ s/^[\s\r\n]+//gm;
  $cleanse_tmp =~ s/[\s\r\n]+$//gm;
  $_[0] = $cleanse_tmp;
}

sub clean {
  $cleanse_tmp = $_[0];
  $cleanse_tmp =~ s/^[\s\r\n]+//gm;
  $cleanse_tmp =~ s/[\s\r\n]+$//gm;
  $_[0] = $cleanse_tmp;
}

# Return string wordwrapped and indented.
sub wordwrap {
  $ww_indent = $_[0];
  $ww_text = $_[1];
  $ww_break = $_[2];
  $ww_wid = $_[3];
  cleanse($ww_text);
  $ww_out = '';
  $ww_text =~ s/\r//gm;
  @ww_lines = split(/\n/, $ww_text);
  foreach $ww_line (@ww_lines) {
    @ww_words = split(' ', $ww_line);
    $ww_line_out = $ww_indent;
    foreach $ww_word (@ww_words) {
      if (length($ww_line_out)+length($ww_word) > $ww_wid) {
        # Don't break before or after numbers.
        # if ( ($ww_line_out !~ /[\-0-9]$/) and
        #      ($ww_word !~ /^[\-0-9]/) ) {
          if ( ($ww_out ne '') and ($ww_line_out ne $ww_indent) ) {
            $ww_out = $ww_out.$ww_break }
          if ($ww_line_out ne $ww_indent) {
            $ww_out = $ww_out.$ww_line_out;
            $ww_line_out = $ww_indent;
          }
        # }
      }
      if ($ww_line_out ne $ww_indent) { $ww_line_out = $ww_line_out.' ' }
      $ww_line_out = $ww_line_out.$ww_word;
    }
    if ($ww_line_out ne $ww_indent) {  # Finish the leftovers.
      if ($ww_out ne '') { $ww_out = $ww_out.$ww_break }
      $ww_out = $ww_out.$ww_line_out; 
    }
    $ww_out = $ww_out.$ww_break; 
  }
  $ww_out =~ s/$ww_break$ww_break/$ww_break/g;
  $ww_out = substr($ww_out, 0, length($ww_out)-length($ww_break));
  return $ww_out;
}

# Returns $CRC_out for string $CRC_in
sub CRC_Calc {
  $CRC_out = 0;
  for ($CRC_Loop = 0;
       ($CRC_Loop < length($CRC_in)) and ($CRC_Loop < 255);
       $CRC_Loop++) {
    # Only evaluate printable non-space characters.
    $CRC_Byte = ord(lc(substr($CRC_in,$CRC_Loop,1)));
    if (($CRC_Byte >= ord(' ')) and ($CRC_Byte <= ord('~'))) {
      # Textbook CRC equation.
      for ($CRC_BitLp = 0; $CRC_BitLp < 8; $CRC_BitLp++) {
        $CRC_Flag = (($CRC_out & 0x8000) != 0x0000);
        $CRC_out = $CRC_out << 1;
        if (($CRC_Byte & 0x0080) != 0x0000) {
          $CRC_out = $CRC_out | 0x0001
        }
        $CRC_Byte = ($CRC_Byte & 0x007F) << 1;
        if ($CRC_Flag) {
          $CRC_out = ($CRC_out ^ 0x1021) & 0xFFFF
        }
      }
    }
  }
}

$sole_arg = '';
$cmdline_argcnt = 0;
# Collect environment.
sub GetFormInput {
  local ($buf);
  # Reads all get or post form values in ENV space.
  # Alternately takes -x= format command line argument equivalents.
  $buf = '';
  (*fval) = @_ if @_;
  if ( (! $local_mode) || (@ARGV < 1) ) {
    if ($ENV{'REQUEST_METHOD'} eq 'POST') {
      read(STDIN,$buf,$ENV{'CONTENT_LENGTH'});
    } else {
      $buf=$ENV{'QUERY_STRING'};
    }
  }
  if ($buf !~ /[a-zA-Z0-9]/) {
    $cmdline_argcnt = @ARGV;
    for ($arg_lp = 0; $arg_lp < $cmdline_argcnt; $arg_lp++) {
      if (substr($ARGV[$arg_lp],0,3) =~ /\-[a-z]\=/) {
        $buf .= '&'.substr($ARGV[$arg_lp],1,length($ARGV[$arg_lp])-1);
      }
    }
    if (! $buf) { $buf = $ARGV[0]; }
  }
  if ($buf eq "") {
    return 0;
  } else {
    @fval=split(/&/,$buf);
    foreach $i (0 .. $#fval) {
      ($name,$val)=split (/=/,$fval[$i],2);
      $val=~tr/+/ /;
      $val=~ s/%(..)/pack("c",hex($1))/ge;
      $name=~tr/+/ /;
      $name=~ s/%(..)/pack("c",hex($1))/ge;
      if (! $sole_arg) { $sole_arg = $name; }
      $name = uc($name);
      if (!defined($field{$name})) {
        $field{$name}=$val;
      } else {
        $field{$name} .= ",$val";
        #if you want multi-selects to goto into an array change to:
        #$field{$name} .= "\0$val";
      }
    }
  }
  return 1;
}
&GetFormInput;

# Spruce up URL field.
sub FixURL {
  $Fix_Out = $_[0];
  cleanse($Fix_Out);
  $Fix_Out =~ s/<//g;
  $Fix_Out =~ s/ //g;
  $Fix_Out =~ s/^http://i;
  $Fix_Out =~ s/^\/\///;
  return $Fix_Out;
}

# Convert troublesome characters to HEX for storing.
sub xe {  # heX Encode
  $safe_str= $_[0];
  $safe_out = '';
  for ($safe_lp = 0; $safe_lp < length($safe_str); $safe_lp++ ) {
    $safe_char = substr($safe_str,$safe_lp,1);
    if ( ($safe_char le ' ') or ($safe_char gt 'z') or
         ($safe_char eq '%') or ($safe_char eq '~') or
         ($safe_char eq '+') or
         ($safe_char eq "\'") or ($safe_char eq '"') or
         ($safe_char eq '<') or ($safe_char eq '>') or
         ($safe_char eq '&') or ($safe_char eq '#') or
         ($safe_char eq '@') ) {
      $safe_char = '%'.sprintf("%02x", ord($safe_char)) }
    $safe_out .= $safe_char;
  }
  return $safe_out;
}

# Convert troublesome characters to OCTAL for HTML display.
sub oe {  # Octal Encode
  $safe_str= $_[0];
  $safe_out = '';
  for ($safe_lp = 0; $safe_lp < length($safe_str); $safe_lp++ ) {
    $safe_char = substr($safe_str,$safe_lp,1);
    if ( ($safe_char lt ' ') or ($safe_char gt 'z') or
         ($safe_char eq '%') or ($safe_char eq '~') or
         ($safe_char eq '+') or
         ($safe_char eq "\'") or ($safe_char eq '"') or
         ($safe_char eq '<') or ($safe_char eq '>') or
         ($safe_char eq '&') or ($safe_char eq '#') or
         ($safe_char eq '@') or ($safe_char eq '|') ) {
      $safe_char = '&#'.sprintf("%03d;", ord($safe_char)) }
    $safe_out .= $safe_char;
  }
  return $safe_out;
}

# Convert HEX encoded troublesome characters back to actual.
sub xd {  # heX Decode
  $safe_str = $_[0];
  $safe_str =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("c",hex($1))/ge;
  $safe_str =~ s/\r//gm;
  return $safe_str;
}

# Return day of week index 0-7 where 0=Sunday
sub Get_DOW {
  $DOW_YYYY = $_[0];
  $DOW_MM = $_[1];
  $DOW_DD = $_[2];
  # convert date to days since 1999.01.01
  $YY = $DOW_YYYY - 1999;
  # start with elapsed leap year days
  if ($DOW_YYYY >= 2000) {
      $DaTotal = int(($DOW_YYYY - 2000) / 4) }
  # compensate if current year is leap year but leap day is not past
  if ( (($DOW_YYYY % 4) == 0) and ($DOW_MM < 3) ) {
    $DaTotal-- }
  # add days for past years
  $DaTotal = $DaTotal + $YY * 365;
  $DTLp = 1;
  # add days for elapsed months in year
  while ($DTLp < $DOW_MM) {
    $DaTotal = $DaTotal + $DaysPerMonth[$DTLp - 1];
      $DTLp++;
  }
  # add elapsed days in month to finish
  $DaTotal = $DaTotal + $DOW_DD - 1;
  $DOW = ($DaTotal + 6) % 7;
  return $DOW;
}

# Given a date, return Chicago seconds since 1970.01.01
sub MakeTime {
  $MT_YYYY = $_[0];
  $MT_MM = $_[1];
  $MT_DD = $_[2];
  $MT_HR = $_[3];
  $MT_MN = $_[4];
  $MT_SC = $_[5];
  # convert date to days since 1970.01.01
  $YY = $MT_YYYY - 1970;
  # start with elapsed leap year days (1972=1st)
  $DaTotal = int(($MT_YYYY - 1968) / 4);
  # compensate if current year is leap year but leap day is not past
  if ( ( ($MT_YYYY % 4) == 0 ) and ($MT_MM < 3) ) {
    $DaTotal--;
  }
  # add days for past years
  $DaTotal = $DaTotal + ($YY * 365);
  $DTLp = 1;
  # add days for elapsed months in year
  while ($DTLp < $MT_MM) {
    $DaTotal = $DaTotal + $DaysPerMonth[$DTLp - 1];
      $DTLp++;
  }
  # add elapsed days in month
  $DaTotal = $DaTotal + $MT_DD - 1;
  # multiply up to seconds
  $SecTotal = $DaTotal * (24 * 60 * 60);
  $SecTotal = $SecTotal + ($MT_HR * (60 * 60)) + ($MT_MN * 60) + $MT_SC;
  return $SecTotal;
}

# Convert a Chicago seconds value to GMT so gmtime returns correct values.
sub ctogsec {
  $in_time = $_[0];
  return ($in_time - ($TZ_adjust * 60 * 60))
}

# Convert a GMT seconds value to Chicago so current time reads right.
sub gtocsec {
  $in_time = $_[0];
  return ($in_time + ($TZ_adjust * 60 * 60))
}

sub TrackingLog {
  # Format: date code page memid email affil msg details remote cookies args
  $LogMsg = $_[0];
  $PageCode = $_[1];
  $LogCode = $_[2];
  $LogDetails = $_[3];
  if (! $PAGE_TITLE) { $PAGE_TITLE = uc($PageCode); }
  if ( (! $activitytime_any) &&
       (! $Tracking_Email) && (! $Tracking_MemID) ) {
    $cookie_err_log_msg = "cookies?";
  } else {
    $cookie_err_log_msg = "";
  }
  $log_args = '';
  if ($field{'A'}) { $log_args .= 'A='.$field{'A'}.';'; }
  if ($field{'B'}) { $log_args .= 'B='.&xe(&cleanse($field{'B'})).';'; }
  if ($field{'C'}) { $log_args .= 'C='.$field{'C'}.';'; }
  if ($field{'D'}) { $log_args .= 'D='.$field{'D'}.';'; }
  if ($field{'E'}) { $log_args .= 'E='.$field{'E'}.';'; }
  if ($field{'F'}) { $log_args .= 'F='.$field{'F'}.';'; }
  if ($field{'G'}) { $log_args .= 'G='.$field{'G'}.';'; }
  if ($field{'I'}) { $log_args .= 'I='.$field{'I'}.';'; }
  if ($field{'J'}) { $log_args .= 'J='.$field{'J'}.';'; }
  if ($field{'K'}) { $log_args .= 'K='.$field{'K'}.';'; }
  if ($field{'L'}) { $log_args .= 'L='.$field{'L'}.';'; }
  if ($field{'M'}) { $log_args .= 'M='.$field{'M'}.';'; }
  if ($field{'N'}) { $log_args .= 'N='.$field{'N'}.';'; }
  if ($field{'O'}) { $log_args .= 'O='.$field{'O'}.';'; }
  if ($field{'P'}) { $log_args .= 'P='.$field{'P'}.';'; }
  if ($field{'Q'}) { $log_args .= 'Q='.$field{'Q'}.';'; }
  if ($field{'R'}) { $log_args .= 'R='.$field{'R'}.';'; }
  if ($field{'S'}) { $log_args .= 'S='.&xe(&cleanse($field{'S'})).';'; }
  if ($field{'T'}) { $log_args .= 'T='.$field{'T'}.';'; }
  if ($field{'U'}) { $log_args .= 'U='.$field{'U'}.';'; }
  if ($field{'V'}) { $log_args .= 'V='.$field{'V'}.';'; }
  if ($field{'W'}) { $log_args .= 'W='.$field{'W'}.';'; }
  if ($field{'X'}) { $log_args .= 'X='.$field{'X'}.';'; }
  if ($field{'Y'}) { $log_args .= 'Y='.$field{'Y'}.';'; }
  if (! $log_args) { $log_args = &xe($sole_arg); }
  $log_time = time - ($TZ_adjust * 60 * 60);
  ($LogSec, $LogMin, $LogHr, $LogDa, $LogMo, $LogYr) = localtime($log_time);
  $LogMo++;  $LogYr += 1900;
  $LogYYYYMMDDHHMMSS = sprintf("%04d%02d%02d%02d%02d%02d", $LogYr, $LogMo, $LogDa, $LogHr, $LogMin, $LogSec);
  $logline_date = $LogYYYYMMDDHHMMSS;
  $logline_code = '';
  if ($LogCode !~ /$LOG_TYPE_SYSTEM/i) {
    $logline_code = uc($LogCode);
  }
  $logline_out = $logline_date.'|'.$logline_code.'|'.$PageCode.'|';
  if ($CurrMemID) {
    $logline_out .= $CurrMemID;
  } else {
    if ($Tracking_MemID) {
      $logline_out .= '('.$Tracking_MemID.')';
    }
  }
  $logline_out .= '|'.$Tracking_Email.'|'.$CurrMemAffilCode.'|'.&cleanse($LogMsg).'|'.cleanse($LogDetails).'|'.$ENV{'REMOTE_ADDR'}."|".$cookie_err_log_msg."|".$log_args.'|'.$ENV{'HTTP_REFERER'}."|".$line_end;
  open (TRACK_LOG, ">> ".lc($LOG_TYPE_SYSTEM).".log");
  print TRACK_LOG $logline_out;
  close (TRACK_LOG);
  chmod(0666, lc($LOG_TYPE_SYSTEM).".log");
  if ($LogCode !~ /$LOG_TYPE_SYSTEM/i) {
    open (TRACK_LOG, ">> ".lc($LogCode).".new");
    print TRACK_LOG $logline_out;
    close (TRACK_LOG);
    chmod(0666, lc($LogCode).".new");
  }
}

# Redirect browser to a new URL.
# Replaces use of "Location:" tag not supported by AOL.
# MUST be used before "Content-type" header.
sub URLRedir {
  $new_url = $_[0];
  $new_msg = $_[1];
  if ($new_msg eq '') { $new_msg = 'forwarded to the requested content' }
  print "Location: ".$new_url."\n\n";
  print "Content-type: text/html; charset=UTF-8\n\n";
  print "<html>".$line_end;
  print "<head>".$line_end;
  print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"3;URL=".$new_url."\">".$line_end;
  print "<title>Redirecting...</title>".$line_end;
  print "<body bgcolor=white>".$line_end;
  print "<font size=3 face=Arial color=red>".$line_end;
  print "<b>You are being ".$new_msg."...</b><br>".$line_end;
  print "<a href=\"".$new_url."\"><font size=2 color=gray>".$new_url."</font></a><br><br>".$line_end;
  print "<font size=1 color=black>If it does not appear soon it may be a dead link or browser problem.".$line_end;
  print "You can <a href=\"".$new_url."\">try again</a>".$line_end;
  print "or <a href=\"/contact.php?s=Redir+trouble.&b=".$new_url."#contact\">report&nbsp;it</a>";
  if ($new_msg eq '') { print " or close this window" };
  print ".</font></font>".$line_end;
  print "</body>".$line_end."</html>".$line_end;
}

sub ops_start {
  if ($cmdline_argcnt < 1) {
    print "<html><head><title>OPS</title>\n";
    print "<link rel='stylesheet' type='text/css' href='".$URL_WEB."default.css'>\n";
    print "</head>".$line_end;
    print "<body bgcolor=white><font class=ssmainsmall>".$line_end;
    # print "<a href='".$URL_WEB."ops.php?v=".int(rand(10000))."'>RETURN TO OPS</a><font class=ssdimtiny>&nbsp;&nbsp;&nbsp;&#149;&nbsp;&nbsp;&nbsp;</font>".$line_end;
    print "<font class=ssmaintiny><a name='top'></a><a href='#bottom'>BOTTOM</a><font size=0><br><br></font></font>".$line_end;
  }
}

sub ops_end {
  if ($cmdline_argcnt < 1) {
    print "<font class=ssmaintiny><font size=0><br><br></font><a name='bottom'></a><a href='#top'>TOP</a><font size=0><br><br></font></font>".$line_end;
    print "</font></body></html>".$line_end;
  }
}

sub sys_email {
  if ( ($email_subject) || ($email_body) ) {
    if (! $email_address) { $email_address = $EMAIL_ADMIN; }
    if (! $email_from) { $email_from = $EMAIL_BOT; }
    $email_out = "To: ".$email_address.$line_end;
    if ( ($mail_prog) and (! $local_mode) ) {
      $email_out .= "Reply-to: ".$email_from.$line_end;
    }
    $email_out .= "From: ".$email_from.$line_end;
    $email_out .= "Subject: ".$email_subject.$line_end.$line_end;
    $email_out .= $email_body.$line_end;
    if ( (! $mail_prog) or ($local_mode) ) {
      open (MAIL, ">> ".$dir_data."email.txt");
      print MAIL $line_end."=======================================".$line_end;
      print MAIL "Date: ".$Today_show.$line_end;
    } else {
      open (MAIL, "|$mail_prog");
    }
    print MAIL $email_out;
    close (MAIL);
    &TrackingLog('Email sent to '.$email_address.' : '.$email_subject,$PAGE_TITLE,$LOG_TYPE_EMAIL);
  }
}

sub sys_email_cc {
  # Copy an email to admin.
  $email_body = "Sent to: ".$email_address.$line_end.$email_body.$email_insert;
  $email_subject = '[Notification] '.$email_subject;
  $email_from = $EMAIL_BOT;
  $email_address = $EMAIL_ADMIN;
  &sys_email();
}

sub ucwords {
  $ucw_in = $_[0];
  $ucw_in = lc($ucw_in);
  $ucw_in = "\u$ucw_in";
  $ucw_in =~ s/_/ /g;
  @ucw_parts = split(/ /,$ucw_in);
  $ucw_part_last = $#ucw_parts;
  $ucw_out = "";
  for ($ucw_lp=0; $ucw_lp <= $ucw_part_last; $ucw_lp++) {
    $ucw_part = $ucw_parts[$ucw_lp];
    $ucw_part = "\u$ucw_part";
    if ($ucw_out) { $ucw_out .= ' '; }
    $ucw_out .= $ucw_part;
  }
  @ucw_parts = split(/-/,$ucw_out);
  $ucw_part_last = $#ucw_parts;
  $ucw_out = "";
  for ($ucw_lp=0; $ucw_lp <= $ucw_part_last; $ucw_lp++) {
    $ucw_part = $ucw_parts[$ucw_lp];
    $ucw_part = "\u$ucw_part";
    if ($ucw_out) { $ucw_out .= '-'; }
    $ucw_out .= $ucw_part;
  }
  $ucw_out =~ s/ And / and /g;
  $ucw_out =~ s/ Or / or /g;
  $ucw_out =~ s/ Of / of /g;
  &clean($ucw_out);
  return $ucw_out;
}

1;
